<template>
  <q-page padding class="page">
    <div class="q-mb-md">
      <q-input
        @keyup.enter="addTodo"
        outlined
        v-model=newTodo
        placeholder="Add a new todo..."
      >
      <template v-slot:append>
        <q-btn icon="add" round @click="addTodo" color=blue-4></q-btn>
      </template>
      </q-input>
    </div>

    <q-list bordered separator>

      <q-item
        v-for="todo in todos"
        :key="todo.id"
        :class="todo.isCompleted ? 'bg-green-2' : 'bg-blue-2'"
        v-ripple
        side top
       >

        <q-checkbox v-model="todo.isCompleted" keep-color color="teal"/>
        <q-item-section>
          <q-item-label :class="{ 'text-strikethrough' : todo.isCompleted }">
             {{ todo.title }}
          </q-item-label>
        </q-item-section>

        <q-item-section side>
          <q-btn color="red" icon="delete" size="sm" @click="deleteTodo(todo.id)"/>
        </q-item-section>

      </q-item>
    </q-list>
  </q-page>
</template>
<script>

import { defineComponent,ref } from 'vue';

export default defineComponent({
  name: 'IndexPage',
  setup () {
    return {
      checked: ref(false)
    }
  },
  methods: {
    addTodo(){
      if (this.newTodo.trim() === "") {
        return
      }

      let newID = 1

      if (this.todos.length != 0){
        newID = (this.todos[this.todos.length - 1]).id + 1
      }

      this.todos.push({
        id: newID,
        title: this.newTodo,
        isCompleted: false
      })
      this.newTodo = ""
    },
    deleteTodo(id) {
      const index = this.todos.findIndex(todo => todo.id === id);
      this.todos.splice(index,1)
    }
  },
  data(){
    return {
      newTodo: "",
      todos: [
        {
          id: 1,
          title: "Watch a new movie",
          isCompleted: false,
        },
        {
          id: 2,
          title: "Finish my task",
          isCompleted: false,
        }
      ],
    }
  }
})
</script>
